## uhd 3.14.0.0-release

=== python/CMakeLists.txt ===
#
# Copyright 2017-2018 Ettus Research, a National Instruments Company
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# This file included, use CMake directory variables
########################################################################

PYTHON_CHECK_MODULE(
    "virtualenv"
    "sys" "hasattr(sys, 'real_prefix')"
    HAVE_PYTHON_VIRTUALENV
)

# Get include dirs
include_directories(${PYTHON_INCLUDE_DIRS})
execute_process(
    COMMAND "${PYTHON_EXECUTABLE}" -c
    "from __future__ import print_function\ntry:\n import numpy\n import os\n inc_path = numpy.get_include()\n if os.path.exists(os.path.join(inc_path, 'numpy', 'arrayobject.h')):\n  print(inc_path, end='')\nexcept:\n pass"
    OUTPUT_VARIABLE PYTHON_NUMPY_INCLUDE_DIR)

# Build pyuhd library
add_library(pyuhd SHARED pyuhd.cpp)
target_include_directories(pyuhd PUBLIC
    ${PYTHON_NUMPY_INCLUDE_DIR}
    ${CMAKE_SOURCE_DIR}/lib
)

target_link_libraries(pyuhd ${BOOST_PYTHON_LIBRARY} ${Boost_LIBRARIES} ${PYTHON_LIBRARY} uhd)
# Copy pyuhd library to the staging directory
if(WIN32)
    set(PYUHD_LIBRARY_NAME libpyuhd.pyd)
else()
    set(PYUHD_LIBRARY_NAME libpyuhd${CMAKE_SHARED_LIBRARY_SUFFIX})
endif(WIN32)

add_custom_command(TARGET pyuhd
    POST_BUILD COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:pyuhd> ${CMAKE_CURRENT_BINARY_DIR}/uhd/${PYUHD_LIBRARY_NAME})

set(PYUHD_FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/__init__.py
  ${CMAKE_CURRENT_SOURCE_DIR}/types.py
  ${CMAKE_CURRENT_SOURCE_DIR}/usrp.py
  ${CMAKE_CURRENT_SOURCE_DIR}/filters.py
)

set(SETUP_PY_IN    "${CMAKE_CURRENT_SOURCE_DIR}/setup.py.in")
set(SETUP_PY       "${CMAKE_CURRENT_BINARY_DIR}/setup.py")
set(TIMESTAMP_FILE "${CMAKE_CURRENT_BINARY_DIR}/build/timestamp")
# convert binary directory to native format to use in SETUP_PY file.
file(TO_NATIVE_PATH ${CMAKE_CURRENT_BINARY_DIR} NATIVE_CURRENT_BINARY_DIR)
configure_file(${SETUP_PY_IN} ${SETUP_PY})

add_custom_command(OUTPUT ${TIMESTAMP_FILE}
  COMMAND ${CMAKE_COMMAND} -E copy ${PYUHD_FILES} ${CMAKE_CURRENT_BINARY_DIR}/uhd
  COMMAND ${PYTHON_EXECUTABLE} ${SETUP_PY} -q build
  COMMAND ${CMAKE_COMMAND} -E touch ${TIMESTAMP_FILE}
  DEPENDS ${PYUHD_FILES})

add_custom_target(pyuhd_library ALL DEPENDS ${TIMESTAMP_FILE} pyuhd)
if(HAVE_PYTHON_VIRTUALENV)
    # In virtualenvs, let setuptools do its thing
    install(CODE "execute_process(COMMAND ${PYTHON_EXECUTABLE} ${SETUP_PY} -q install --force)")
else()
    # Otherwise, use distutils to determine the correct relative path for Python
    # packages, and install to our prefix
    if(NOT DEFINED UHD_PYTHON_DIR)
        execute_process(COMMAND ${PYTHON_EXECUTABLE} -c
            "from __future__ import print_function;\
            from distutils import sysconfig;\
            print(sysconfig.get_python_lib(plat_specific=True, prefix='${CMAKE_INSTALL_PREFIX}'));"
            OUTPUT_VARIABLE UHD_PYTHON_DIR OUTPUT_STRIP_TRAILING_WHITESPACE
        )
    endif(NOT DEFINED UHD_PYTHON_DIR)
    file(TO_CMAKE_PATH ${UHD_PYTHON_DIR} UHD_PYTHON_DIR)

    message(STATUS "Utilizing the python install directory: ${UHD_PYTHON_DIR}")
    install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/uhd DESTINATION ${UHD_PYTHON_DIR} COMPONENT pythonapi)
endif(HAVE_PYTHON_VIRTUALENV)

=== include/uhd/rfnoc/CMakeLists.txt ===
#
# Copyright 2014-2016 Ettus Research LLC
# Copyright 2018 Ettus Research, a National Instruments Company
#
# SPDX-License-Identifier: GPL-3.0
#

if(ENABLE_RFNOC)
    UHD_INSTALL(FILES
        # Infrastructure
        block_ctrl_base.hpp
        block_ctrl.hpp
        blockdef.hpp
        block_id.hpp
        constants.hpp
        graph.hpp
        node_ctrl_base.hpp
        node_ctrl_base.ipp
        rate_node_ctrl.hpp
        scalar_node_ctrl.hpp
        sink_block_ctrl_base.hpp
        sink_node_ctrl.hpp
        source_block_ctrl_base.hpp
        source_node_ctrl.hpp
        stream_sig.hpp
        terminator_node_ctrl.hpp
        tick_node_ctrl.hpp
        # Block controllers
        ddc_block_ctrl.hpp
        dma_fifo_block_ctrl.hpp
        duc_block_ctrl.hpp
        fir_block_ctrl.hpp
        null_block_ctrl.hpp
        radio_ctrl.hpp
        replay_block_ctrl.hpp
        siggen_block_ctrl.hpp
        window_block_ctrl.hpp
        DESTINATION ${INCLUDE_DIR}/uhd/rfnoc
        COMPONENT headers
    )
endif(ENABLE_RFNOC)

add_subdirectory(blocks)
#add_subdirectory(components)

=== lib/usrp/b100/CMakeLists.txt ===
#
# Copyright 2011-2013,2015 Ettus Research LLC
# Copyright 2018 Ettus Research, a National Instruments Company
#
# SPDX-License-Identifier: GPL-3.0
#

########################################################################
# This file included, use CMake directory variables
########################################################################

########################################################################
# Conditionally configure the B100 support
########################################################################
if(ENABLE_B100)
    LIBUHD_APPEND_SOURCES(
        ${CMAKE_CURRENT_SOURCE_DIR}/b100_impl.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/clock_ctrl.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/codec_ctrl.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/dboard_iface.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/io_impl.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/mb_eeprom.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/usb_zero_copy_wrapper.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/fifo_ctrl_excelsior.cpp
    )
endif(ENABLE_B100)

=== lib/usrp/mpmd/CMakeLists.txt ===
#
# Copyright 2017 Ettus Research, a National Instruments Company
#
# SPDX-License-Identifier: GPL-3.0
#

if(ENABLE_MPMD)
    if(ENABLE_LIBERIO)
        message(STATUS "Compiling MPMD with liberio support...")
        add_definitions(-DHAVE_LIBERIO)
    endif(ENABLE_LIBERIO)

    if(ENABLE_DPDK)
        message(STATUS "Compiling MPMD with DPDK support...")
        add_definitions(-DHAVE_DPDK)
    endif(ENABLE_DPDK)

    LIBUHD_APPEND_SOURCES(
        ${CMAKE_CURRENT_SOURCE_DIR}/mpmd_find.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/mpmd_image_loader.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/mpmd_impl.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/mpmd_mboard_impl.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/mpmd_prop_tree.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/mpmd_xport.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/mpmd_xport_mgr.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/mpmd_xport_ctrl_udp.cpp
    )

    if(ENABLE_LIBERIO)
        LIBUHD_APPEND_SOURCES(
            ${CMAKE_CURRENT_SOURCE_DIR}/mpmd_xport_ctrl_liberio.cpp
        )
    endif(ENABLE_LIBERIO)

    if(ENABLE_DPDK)
        LIBUHD_APPEND_SOURCES(
            ${CMAKE_CURRENT_SOURCE_DIR}/mpmd_xport_ctrl_dpdk_udp.cpp
        )
    endif(ENABLE_DPDK)

endif(ENABLE_MPMD)

=== cmake/debian/control ===
Source: uhd
Section: science
Priority: optional
Maintainer: Ettus Research <packages@ettus.com>
Uploaders: Martin Braun <martin.braun@ettus.com>
Build-Depends:  cmake,
                debhelper (>= 9),
                doxygen,
                libboost-date-time-dev,
                libboost-dev,
                libboost-filesystem-dev,
                libboost-program-options-dev,
                libboost-python-dev,
                libboost-regex-dev,
                libboost-serialization-dev,
                libboost-system-dev,
                libboost-test-dev,
                libboost-thread-dev,
                libncurses5-dev,
                libusb-1.0-0-dev [linux-any],
                libusb2-dev [kfreebsd-any],
                pkg-config,
                python-dev,
                python-mako,
                python-requests
Standards-Version: 3.9.7
Homepage: https://www.ettus.com
Vcs-Git: git://github.com/EttusResearch/uhd.git

Package: uhd-host
Architecture: any
Depends: adduser,
         libuhd3.14.0 (= ${binary:Version}),
         python,
         python-requests,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: curl, procps, python-tk
Suggests: gnuradio
Description: hardware driver for Ettus Research products - host apps
 Host utilities for the USRP Hardware Driver for Ettus Research products.
 .
 The supported devices provide analog radio receiver and transmitter hardware
 along with digital interfaces for getting signals to and from a software
 defined radio running on the host computer.
 .
 This package includes the uhd_find_devices application to locate and
 configure attached peripherals, the uhd_usrp_probe application to
 display hardware configuration information, and Doxygen generated
 documentation.

Package: libuhd3.14.0
Architecture: any
Section: libs
Pre-Depends: ${misc:Pre-Depends}
Depends: python, adduser, ${shlibs:Depends}, ${misc:Depends}
Suggests: gnuradio
Replaces: libuhd003
Multi-Arch: same
Description: hardware driver for Ettus Research products
 Host library for the USRP Hardware Driver for Ettus Research products.
 .
 The supported devices provide analog radio receiver and transmitter hardware
 along with digital interfaces for getting signals to and from a software
 defined radio running on the host computer.

Package: libuhd-dev
Architecture: any
Section: libdevel
Depends: libuhd3.14.0 (= ${binary:Version}), python, ${misc:Depends}, ${shlibs:Depends}
Suggests: gnuradio
Description: universal hardware driver for Ettus Research products
 Host library for the USRP Hardware Driver for Ettus Research products.
 .
 The supported devices provide analog radio receiver and transmitter hardware
 along with digital interfaces for getting signals to and from a software
 defined radio running on the host computer.
 .
 This package contains the header files and documentation for
 developing with libuhd.

## uhd 3.14.1.0-release

=== examples/CMakeLists.txt ===
#
# Copyright 2010-2015 Ettus Research LLC
# Copyright 2018 Ettus Research, a National Instruments Company
#
# SPDX-License-Identifier: GPL-3.0
#

########################################################################
# example applications
########################################################################
set(example_sources
    benchmark_rate.cpp
    network_relay.cpp
    rx_multi_samples.cpp
    rx_samples_to_file.cpp
    rx_samples_to_udp.cpp
    rx_timed_samples.cpp
    test_dboard_coercion.cpp
    test_messages.cpp
    test_pps_input.cpp
    test_timed_commands.cpp
    tx_bursts.cpp
    tx_samples_from_file.cpp
    tx_timed_samples.cpp
    tx_waveforms.cpp
    txrx_loopback_to_file.cpp
    usrp_list_sensors.cpp
    latency_test.cpp
    gpio.cpp
    sync_to_gps.cpp
)

if(ENABLE_RFNOC)
    list(APPEND
        example_sources
        rfnoc_nullsource_ce_rx.cpp
        rfnoc_rx_to_file.cpp
        rfnoc_radio_loopback.cpp
        benchmark_streamer.cpp
    )
endif(ENABLE_RFNOC)

if(ENABLE_OCTOCLOCK)
    list(APPEND example_sources test_clock_synch.cpp)
endif(ENABLE_OCTOCLOCK)

#for each source: build an executable and install
foreach(example_source ${example_sources})
    get_filename_component(example_name ${example_source} NAME_WE)
    add_executable(${example_name} ${example_source})
    target_link_libraries(${example_name} uhd ${Boost_LIBRARIES})
    UHD_INSTALL(TARGETS ${example_name} RUNTIME DESTINATION ${PKG_LIB_DIR}/examples COMPONENT examples)
endforeach(example_source)

########################################################################
# ASCII Art DFT - requires curses, so this part is optional
########################################################################
find_package(Curses)

if(CURSES_FOUND)
    include_directories(${CURSES_INCLUDE_DIR})
    add_executable(rx_ascii_art_dft rx_ascii_art_dft.cpp)
    target_link_libraries(rx_ascii_art_dft uhd ${CURSES_LIBRARIES} ${Boost_LIBRARIES})
    UHD_INSTALL(TARGETS rx_ascii_art_dft RUNTIME DESTINATION ${PKG_LIB_DIR}/examples COMPONENT examples)

    add_executable(twinrx_freq_hopping twinrx_freq_hopping.cpp)
    target_link_libraries(twinrx_freq_hopping uhd ${CURSES_LIBRARIES} ${Boost_LIBRARIES})
    UHD_INSTALL(TARGETS twinrx_freq_hopping RUNTIME DESTINATION ${PKG_LIB_DIR}/examples COMPONENT examples)
endif(CURSES_FOUND)

########################################################################
# Examples using C API
########################################################################
if(ENABLE_C_API)
    #
    # Check if this particular C99 feature is available with this compiler
    #
    include(CheckCSourceCompiles)
    CHECK_C_SOURCE_COMPILES("
    typedef struct {
        int bar;
        int baz;
    } foo;

    int main()
    {
        foo wat = {
            .bar = 1,
            .baz = 2
        };

        return 0;
    }
    " HAVE_C99_STRUCTDECL)

    if(HAVE_C99_STRUCTDECL)
        add_subdirectory(getopt)
        include_directories(${CMAKE_CURRENT_SOURCE_DIR}/getopt)

        set(C_API_EXAMPLES
            rx_samples_c
            tx_samples_c
        )

        foreach(example ${C_API_EXAMPLES})
            add_executable(${example} ${example}.c)
            target_link_libraries(${example} uhd getopt)
            if(UNIX)
                target_link_libraries(${example} m)
            endif(UNIX)
            UHD_INSTALL(TARGETS ${example} RUNTIME DESTINATION ${PKG_LIB_DIR}/examples COMPONENT examples)
        endforeach(example ${C_API_EXAMPLES})
    endif(HAVE_C99_STRUCTDECL)
endif(ENABLE_C_API)

if(ENABLE_PYTHON_API)
    add_subdirectory(python)
endif(ENABLE_PYTHON_API)

=== tests/CMakeLists.txt ===

# Copyright 2010-2015 Ettus Research LLC
# Copyright 2018 Ettus Research, a National Instruments Company
#
# SPDX-License-Identifier: GPL-3.0
#

########################################################################
# unit test support
########################################################################
include(UHDUnitTest)

########################################################################
# build test common
########################################################################
set(test_common_SOURCEDIR ${CMAKE_CURRENT_SOURCE_DIR}/common)
add_subdirectory(common)
link_directories(${test_common_SOURCEDIR})

########################################################################
# unit test suite
########################################################################
set(test_sources
    addr_test.cpp
    buffer_test.cpp
    byteswap_test.cpp
    cast_test.cpp
    cal_container_test.cpp
    chdr_test.cpp
    constrained_device_args_test.cpp
    convert_test.cpp
    dict_test.cpp
    eeprom_utils_test.cpp
    error_test.cpp
    fp_compare_delta_test.cpp
    fp_compare_epsilon_test.cpp
    gain_group_test.cpp
    log_test.cpp
    math_test.cpp
    narrow_cast_test.cpp
    property_test.cpp
    ranges_test.cpp
    sid_t_test.cpp
    sensors_test.cpp
    soft_reg_test.cpp
    sph_recv_test.cpp
    sph_send_test.cpp
    subdev_spec_test.cpp
    time_spec_test.cpp
    tasks_test.cpp
    vrt_test.cpp
    expert_test.cpp
    fe_conn_test.cpp
)

set(benchmark_sources
    packet_handler_benchmark.cpp
)

#turn each test cpp file into an executable with an int main() function
add_definitions(-DBOOST_TEST_DYN_LINK -DBOOST_TEST_MAIN)

if(ENABLE_RFNOC)
    list(APPEND test_sources
        block_id_test.cpp
        blockdef_test.cpp
        device3_test.cpp
        graph_search_test.cpp
        node_connect_test.cpp
        rate_node_test.cpp
        stream_sig_test.cpp
        tick_node_test.cpp
    )
endif(ENABLE_RFNOC)

if(ENABLE_C_API)
    list(APPEND test_sources
        eeprom_c_test.c
        error_c_test.cpp
        ranges_c_test.c
        sensors_c_test.c
        string_vector_c_test.c
        subdev_spec_c_test.c
    )
endif(ENABLE_C_API)

include_directories("${CMAKE_SOURCE_DIR}/lib/include")
include_directories("${CMAKE_CURRENT_SOURCE_DIR}/common")

#for each source: build an executable, register it as a test
foreach(test_source ${test_sources})
    get_filename_component(test_name ${test_source} NAME_WE)
    add_executable(${test_name} ${test_source})
    target_link_libraries(${test_name} uhd uhd_test ${Boost_LIBRARIES})
    UHD_ADD_TEST(${test_name} ${test_name})
    UHD_INSTALL(TARGETS ${test_name} RUNTIME DESTINATION ${PKG_LIB_DIR}/tests COMPONENT tests)
endforeach(test_source)

#for benchmarks, build executable but do not register
foreach(benchmark_source ${benchmark_sources})
    get_filename_component(benchmark_name ${benchmark_source} NAME_WE)
    add_executable(${benchmark_name} ${benchmark_source})
    target_link_libraries(${benchmark_name} uhd uhd_test ${Boost_LIBRARIES})
    UHD_INSTALL(TARGETS ${benchmark_name} RUNTIME DESTINATION ${PKG_LIB_DIR}/tests COMPONENT tests)
endforeach(benchmark_source)

# Other tests that don't directly link with libuhd: (TODO find a nicer way to do this)
if(ENABLE_DPDK)
    include_directories(${CMAKE_BINARY_DIR}/lib/transport/)
    include_directories(${CMAKE_SOURCE_DIR}/lib/transport/)
    find_package(DPDK)
    include_directories(${DPDK_INCLUDE_DIR})
    add_executable(dpdk_test
        dpdk_test.cpp
        ${CMAKE_SOURCE_DIR}/lib/utils/config_parser.cpp
        ${CMAKE_SOURCE_DIR}/lib/utils/paths.cpp
        ${CMAKE_SOURCE_DIR}/lib/utils/pathslib.cpp
        ${CMAKE_SOURCE_DIR}/lib/utils/prefs.cpp
        ${CMAKE_SOURCE_DIR}/lib/transport/dpdk_zero_copy.cpp
    )
    target_link_libraries(dpdk_test uhd ${Boost_LIBRARIES} ${DPDK_LIBRARIES})
    # For the DPDK test, don't automatically run (requires specific config)
    UHD_INSTALL(TARGETS dpdk_test RUNTIME DESTINATION ${PKG_LIB_DIR}/tests COMPONENT tests)
ENDIF(ENABLE_DPDK)

include_directories(${CMAKE_BINARY_DIR}/lib/rfnoc/nocscript/)
include_directories(${CMAKE_SOURCE_DIR}/lib/rfnoc/nocscript/)
add_executable(nocscript_expr_test
    nocscript_expr_test.cpp
    ${CMAKE_SOURCE_DIR}/lib/rfnoc/nocscript/expression.cpp
)
target_link_libraries(nocscript_expr_test uhd ${Boost_LIBRARIES})
UHD_ADD_TEST(nocscript_expr_test nocscript_expr_test)
UHD_INSTALL(TARGETS nocscript_expr_test RUNTIME DESTINATION ${PKG_LIB_DIR}/tests COMPONENT tests)

add_executable(nocscript_ftable_test
    nocscript_ftable_test.cpp
    ${CMAKE_SOURCE_DIR}/lib/rfnoc/nocscript/function_table.cpp
    ${CMAKE_SOURCE_DIR}/lib/rfnoc/nocscript/expression.cpp
)
target_link_libraries(nocscript_ftable_test uhd ${Boost_LIBRARIES})
UHD_ADD_TEST(nocscript_ftable_test nocscript_ftable_test)
UHD_INSTALL(TARGETS nocscript_ftable_test RUNTIME DESTINATION ${PKG_LIB_DIR}/tests COMPONENT tests)

add_executable(nocscript_parser_test
    nocscript_parser_test.cpp
    ${CMAKE_SOURCE_DIR}/lib/rfnoc/nocscript/parser.cpp
    ${CMAKE_SOURCE_DIR}/lib/rfnoc/nocscript/function_table.cpp
    ${CMAKE_SOURCE_DIR}/lib/rfnoc/nocscript/expression.cpp
)
target_link_libraries(nocscript_parser_test uhd ${Boost_LIBRARIES})
UHD_ADD_TEST(nocscript_parser_test nocscript_parser_test)
UHD_INSTALL(TARGETS nocscript_parser_test RUNTIME DESTINATION ${PKG_LIB_DIR}/tests COMPONENT tests)

add_executable(config_parser_test
    config_parser_test.cpp
    ${CMAKE_SOURCE_DIR}/lib/utils/config_parser.cpp
)
target_link_libraries(config_parser_test uhd ${Boost_LIBRARIES})
UHD_ADD_TEST(config_parser_test config_parser_test)
UHD_INSTALL(TARGETS
    config_parser_test
    RUNTIME
    DESTINATION ${PKG_LIB_DIR}/tests
    COMPONENT tests
)

add_executable(paths_test
    paths_test.cpp
    ${CMAKE_SOURCE_DIR}/lib/utils/pathslib.cpp
)
# Careful: This is to satisfy the out-of-library build of paths.cpp. This is
# duplicate code from lib/utils/CMakeLists.txt, and it's been simplified.
set(UHD_LIB_DIR "lib")
file(TO_NATIVE_PATH "${CMAKE_INSTALL_PREFIX}" UHD_PKG_PATH)
string(REPLACE "\\" "\\\\" UHD_PKG_PATH "${UHD_PKG_PATH}")
set_source_files_properties(
    ${CMAKE_SOURCE_DIR}/lib/utils/paths.cpp
    PROPERTIES COMPILE_DEFINITIONS
    "UHD_PKG_PATH=\"${UHD_PKG_PATH}\";UHD_LIB_DIR=\"${UHD_LIB_DIR}\""
)
target_link_libraries(paths_test uhd ${Boost_LIBRARIES})
UHD_ADD_TEST(paths_test paths_test)
UHD_INSTALL(TARGETS
    paths_test
    RUNTIME
    DESTINATION ${PKG_LIB_DIR}/tests
    COMPONENT tests
)

########################################################################
# demo of a loadable module
########################################################################
if(MSVC OR APPLE OR LINUX)
    add_library(module_test MODULE module_test.cpp)
    target_link_libraries(module_test uhd)
endif()

add_subdirectory(devtest)

=== lib/rfnoc/CMakeLists.txt ===
#
# Copyright 2014-2015,2017 Ettus Research LLC
# Copyright 2018 Ettus Research, a National Instruments Company
#
# SPDX-License-Identifier: GPL-3.0
#

########################################################################
# This file included, use CMake directory variables
########################################################################

LIBUHD_APPEND_SOURCES(
    # Infrastructure:
    ${CMAKE_CURRENT_SOURCE_DIR}/async_msg_handler.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/block_ctrl_base.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/block_ctrl_base_factory.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/block_ctrl_impl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/blockdef_xml_impl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/block_id.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/ctrl_iface.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/graph_impl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/legacy_compat.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/node_ctrl_base.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/rate_node_ctrl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/rx_stream_terminator.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/scalar_node_ctrl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/sink_block_ctrl_base.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/sink_node_ctrl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/source_block_ctrl_base.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/source_node_ctrl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/stream_sig.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/tick_node_ctrl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/tx_stream_terminator.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/wb_iface_adapter.cpp
    # Default block control classes:
    ${CMAKE_CURRENT_SOURCE_DIR}/ddc_block_ctrl_impl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/duc_block_ctrl_impl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/fir_block_ctrl_impl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/null_block_ctrl_impl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/window_block_ctrl_impl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/radio_ctrl_impl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/siggen_block_ctrl_impl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/dma_fifo_block_ctrl_impl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/replay_block_ctrl_impl.cpp
)

INCLUDE_SUBDIRECTORY(nocscript)

=== lib/transport/uhd-dpdk/CMakeLists.txt ===
#
# Copyright 2018 Ettus Research, a National Instruments Company
#
# SPDX-License-Identifier: GPL-3.0
#

########################################################################
# Add the subdirectories
########################################################################
if(ENABLE_DPDK)
    if(NOT DEFINED UHD_DPDK_CFLAGS)
        message(STATUS "")
        set(UHD_DPDK_CFLAGS "-march=native"
            CACHE STRING "CFLAGS to use when building uhd-dpdk sources")
        message(STATUS "DPDK: Using default UHD_DPDK_CFLAGS=" ${UHD_DPDK_CFLAGS})
    endif(NOT DEFINED UHD_DPDK_CFLAGS)

    include_directories(${CMAKE_CURRENT_SOURCE_DIR})

    LIBUHD_APPEND_SOURCES(
        ${CMAKE_CURRENT_SOURCE_DIR}/uhd_dpdk.c
        ${CMAKE_CURRENT_SOURCE_DIR}/uhd_dpdk_driver.c
        ${CMAKE_CURRENT_SOURCE_DIR}/uhd_dpdk_fops.c
        ${CMAKE_CURRENT_SOURCE_DIR}/uhd_dpdk_udp.c
        ${CMAKE_CURRENT_SOURCE_DIR}/uhd_dpdk_wait.c
    )
    set_source_files_properties(
        ${CMAKE_CURRENT_SOURCE_DIR}/uhd_dpdk.c
        ${CMAKE_CURRENT_SOURCE_DIR}/uhd_dpdk_driver.c
        ${CMAKE_CURRENT_SOURCE_DIR}/uhd_dpdk_fops.c
        ${CMAKE_CURRENT_SOURCE_DIR}/uhd_dpdk_udp.c
        ${CMAKE_CURRENT_SOURCE_DIR}/uhd_dpdk_wait.c
        PROPERTIES COMPILE_FLAGS "${UHD_DPDK_CFLAGS} -D_GNU_SOURCE"
    )
    include_directories(${DPDK_INCLUDE_DIR})
    LIBUHD_APPEND_LIBS(${DPDK_LIBRARIES})
endif(ENABLE_DPDK)

=== lib/usrp/common/CMakeLists.txt ===
#
# Copyright 2011-2013,2016 Ettus Research LLC
# Copyright 2018 Ettus Research, a National Instruments Company
#
# SPDX-License-Identifier: GPL-3.0
#

########################################################################
# This file included, use CMake directory variables
########################################################################
if(ENABLE_USB)
    LIBUHD_APPEND_SOURCES(
        ${CMAKE_CURRENT_SOURCE_DIR}/fx2_ctrl.cpp
    )
endif(ENABLE_USB)

if(ENABLE_E300 OR ENABLE_B200 OR ENABLE_N230 OR ENABLE_E320)
    include_directories("${CMAKE_CURRENT_SOURCE_DIR}/ad9361_driver")
    LIBUHD_APPEND_SOURCES(
        ${CMAKE_CURRENT_SOURCE_DIR}/ad9361_ctrl.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/ad936x_manager.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/ad9361_driver/ad9361_device.cpp
    )
endif(ENABLE_E300 OR ENABLE_B200 OR ENABLE_N230 OR ENABLE_E320)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

LIBUHD_APPEND_SOURCES(
    ${CMAKE_CURRENT_SOURCE_DIR}/adf4001_ctrl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/adf435x.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/adf535x.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/lmx2592.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/apply_corrections.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/validate_subdev_spec.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/recv_packet_demuxer.cpp
)

=== lib/usrp/dboard/CMakeLists.txt ===
#
# Copyright 2010-2011 Ettus Research LLC
# Copyright 2018 Ettus Research, a National Instruments Company
#
# SPDX-License-Identifier: GPL-3.0-or-later
#

########################################################################
# This file included, use CMake directory variables
########################################################################
if(ENABLE_X300 OR ENABLE_USRP1 OR ENABLE_USRP2 OR ENABLE_B100)
    LIBUHD_APPEND_SOURCES(
        ${CMAKE_CURRENT_SOURCE_DIR}/db_basic_and_lf.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/db_rfx.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/db_xcvr2450.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/db_sbx_common.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/db_sbx_version3.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/db_sbx_version4.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/db_cbx.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/db_ubx.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/db_wbx_common.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/db_wbx_version2.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/db_wbx_version3.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/db_wbx_version4.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/db_wbx_simple.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/db_dbsrx.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/db_unknown.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/db_tvrx.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/db_dbsrx2.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/db_tvrx2.cpp
    )
endif(ENABLE_X300 OR ENABLE_USRP1 OR ENABLE_USRP2 OR ENABLE_B100)

if(ENABLE_E300)
    LIBUHD_APPEND_SOURCES(
        ${CMAKE_CURRENT_SOURCE_DIR}/db_e3x0.cpp
    )
endif(ENABLE_E300)

if(ENABLE_X300)
    LIBUHD_APPEND_SOURCES(
        ${CMAKE_CURRENT_SOURCE_DIR}/twinrx/twinrx_ctrl.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/twinrx/twinrx_experts.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/twinrx/twinrx_gain_tables.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/db_twinrx.cpp
    )
endif(ENABLE_X300)

if(ENABLE_N300)
    INCLUDE_SUBDIRECTORY(magnesium)
endif(ENABLE_N300)
if(ENABLE_N320)
    INCLUDE_SUBDIRECTORY(rhodium)
endif(ENABLE_N320)
if(ENABLE_MPMD AND ENABLE_EISCAT)
    INCLUDE_SUBDIRECTORY(eiscat)
endif(ENABLE_MPMD AND ENABLE_EISCAT)

INCLUDE_SUBDIRECTORY(neon)

=== cmake/debian/changelog ===
uhd (3.14.1.0-0ubuntu1) ubuntu_release; urgency=low

  N320: Terminate the DAC when not transmitting
  E320: Add support for rev E
  E320: Added .gitignore for FPGA build products
  X300: Add DPDK support
  X300: add capability to flash NI-2974 FPGA
  X300: Broke two critical timing paths in FPGA
  X300: fixed udp WSA buffer size assignment issue
  E310: Fix DRAM_TEST target build
  B200: Add bootloader for FX3 (fix for B2xx failing to enumerate)
  TwinRX: Expose charge pump current for LO2
  TwinRX: Add low spur mode for LO2
  TwinRX: increase rev c lo1 charge pump default value
  TwinRX: Fix tick rate
  Device3: Constraint send/recv_frame_size based on down/upstream MTU
  Device3: Fix MTU and default frame sizes
  RFNoC: Search all nodes for tick rates
  RFNoC: Change default address for the reg readbacks
  uhd_image_builder: Let the OOT module point to folders not named "rfnoc"
  uhd_image_builder: Add --auto-inst-src
  MPMD: Fix spurious reclaim call after unclaim
  MPMD: Release resources on destruction
  MPM: Add SW/HW compat
  liberio: Release context holder on destruction of last liberio xport
  transport: fixed a pre-mature buffer reset
  nirio: Fix typo in nirio_zero_copy
  GPSD: fix API for 'gps_read'
  AD9361: Fix return values for tune and set_clock_rate
  DUC/DDC: Fix phase reset and accumulation
  cores: Use NSDMI consistently in ?x_dsp_core_3000.*
  Logging: fix deadlock issue on Windows machines
  Logging: Fix ANSI colour codes
  Utils: Add X300/X310 reset utility
  Docs: Improved Windows-related build instructions
  Docs: Add link to README for building custom filesystems for N3xx
  sim: Fixing the port number in use for connection
  tools: Fix for proj creation in ip_utils for tcl-based IP
  tests: Fix mock_ctrl_iface for 32-bit MSVC

 -- Ettus Research <packages@ettus.com>  Fri, 28 Jun 2019 09:00:12 -0800

uhd (3.14.0.0-0ubuntu1) ubuntu_release; urgency=low

  * N320: Add support for N320 and N321
  * USRP-2974: Add support for USRP-2974
  * DPDK: Add DPDK-based sockets-like library (for N3xx)
  * N3xx: clocking API changes for transitioning clock and time sources
  * N3xx: Bump max rev to G/6
  * N3xx: Improve error messages for invalid clock/time settings
  * N3xx: Get RFNoC crossbar baseport from FPGA
  * N3xx: init peripherals before loading FPGA (to fix SFP0 init issues)
  * N3xx: Move Linux kernel to 4.15
  * N3xx/E320: Prepend SDK filename with device name
  * N3xx: Update max rev to 7 (H)
  * N3xx: Remove DDR3 from standard BIST collection
  * N3xx: BIST: Improve DDR3 BIST to check for DmaFIFO
  * N3xx: BIST: Auto-load the AA image for the ddr3 BIST
  * N3xx: BIST: DDR3 test only enumerates first block
  * N310: Modify AD9371 reset function to keep it in reset
  * N310: move init_rf_cal before JESD de/framer bringup
  * N310: Fix sporadic power on failures (requires firmware update)
  * E3xx: Increase spp limit for E3xx radio
  * E320: bist: Fix ref_clock lock test implementation
  * E320: bist: Add link_up test
  * E320: Add all 5 temp sensors, fan sensor and rssi sensors per channel
  * E320: Fix tx/rx atr - antenna and frequency settings
  * E320: Enable devtest for E320
  * E320: images: Separate images package for Aurora image
  * E320: Get RFNoC crossbar baseport from FPGA
  * E320: add fpga_version_hash to e320 device info
  * E310: Fix initialization of antenna and frequency values
  * E31x: Destruct RFNoC before loading idle image
  * X300: Reduce default send_frame_size to 4000 over Ethernet
  * X300: Change Ethernet buffering
  * X300: Log git hash and compat number as debug message
  * X300: Move defaults to their own header
  * X300: Use constrained_args
  * X300: Enable clock_source and time_source device args
  * X300: NIRIO: Demote RPC client cancel/abort to TRACE
  * X300: remove default_buff_args properties
  * X300: Remove 120 MHz master_clock_rate option
  * X300: Set minimum master clock rate to 184.32 MHz
  * X300: Factor our PID -> MB type and MB type -> product name mapping
  * X300: Remove usage of boost::bind
  * X300: Fix compiler warnings related to type conversions
  * X300: Fix tick and sample rate setting
  * X300: Enable ADC gain through RFNoC API
  * X300: Demote NIRIO rpc client start/stop log messages to DEBUG
  * X300: Enable 11.52 MHz and 23.04 MHz system ref rates
  * X300: Enable x300_device_args.to_string()
  * X300: Catch more inconsistencies in x300_device_args
  * X300: Removed invalid 200 MHz sysref rate
  * X300: Change PLL CP currents in x300_clock_ctrl
  * B200: Remove superfluous fake lambda
  * B200: Add support for user regs
  * B200: Fix compiler warnings related to type conversions
  * B100: Move fifo_ctrl_excelsior to b100 subdir
  * B100: Fix fifo_ctrl_excelsior not exiting
  * B100: Remove all Boostisms from fifo_ctrl_excelsior
  * B100: Demote some clocking-related log messages to trace
  * MPM: Get list of temperatures from all thermal zones
  * MPM: add link_speed xport_info
  * MPM: Add __mpm_device__ as usrp_hwd module variable
  * MPM: Add usrp_update_fs
  * MPM: Add i2c APIs for simple transfers
  * MPM: Add vector-based transfer function for i2c
  * MPM: Add variable configuration support to nijesdcore
  * MPM: Add eyescan utility to nijesdcore
  * MPM: Add PRBS-31 testing to nijesdcore
  * MPM: Add convenience function to pull i2c bus from device tree
  * MPM: Open and close i2c file descriptor on every access
  * MPM: Multiprocessing instead of threading for claimer loop
  * MPM: Factor out user EEPROM code into own module
  * MPM: Add gpgga sensor function to GPSd iface
  * MPM: Add bridge mode support
  * MPM: Parameterize max UDP link allocation
  * MPM: xport: add commit_xport docstring
  * MPM: Improve error message on double-claim
  * MPMD: Parallelize broadcast-finding
  * MPMD: add option to enum rfnoc blocks from args
  * MPMD: add link speed to xport udp
  * MPMD: Add API to set RPC timeout atomically
  * MPMD: Move timeout constants to header
  * MPMD: Use new RPC API with timeout
